/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_TEST_AUDIO_Controller_STUB_HPP_
#define V2_TEST_AUDIO_Controller_STUB_HPP_

#include <functional>
#include <sstream>




#include <v2/Test/Audio/Controller.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/ByteBuffer.hpp>
#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

#include <mutex>

#include <CommonAPI/Stub.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Controller. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class ControllerStubAdapter
    : public virtual CommonAPI::StubAdapter,
      public virtual Controller {
 public:
    ///Notifies all remote listeners about a change of value of the attribute IVIDeviceInfo.
    virtual void fireIVIDeviceInfoAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueString &IVIDeviceInfo) = 0;
    ///Notifies all remote listeners about a change of value of the attribute AudioSourceTypes.
    virtual void fireAudioSourceTypesAttributeChanged(const std::vector< std::string > &AudioSourceTypes) = 0;
    ///Notifies all remote listeners about a change of value of the attribute VolumeInfo.
    virtual void fireVolumeInfoAttributeChanged(const ::v2::Test::Audio::Controller::VolumeInfo &VolumeInfo) = 0;
    ///Notifies all remote listeners about a change of value of the attribute KeyValueByteBufferMap.
    virtual void fireKeyValueByteBufferMapAttributeChanged(const ::v2::Test::Audio::Controller::KeyValueByteBuffer &KeyValueByteBufferMap) = 0;
    ///Notifies all remote listeners about a change of value of the attribute DeviceStateMap.
    virtual void fireDeviceStateMapAttributeChanged(const ::v2::Test::Audio::Controller::DeviceStateMap &DeviceStateMap) = 0;
    ///Notifies all remote listeners about a change of value of the attribute StringToShortMap.
    virtual void fireStringToShortMapAttributeChanged(const ::v2::Test::Audio::Controller::StringToShortMap &StringToShortMap) = 0;
    /**
    * Sends a broadcast event for FocusStatusChanged. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireFocusStatusChangedEvent(const std::vector< ::v2::Test::Audio::Controller::FocusStatus > &_focusStatus) = 0;


    virtual void deactivateManagedInstances() = 0;

    void lockIVIDeviceInfoAttribute(bool _lockAccess) {
        if (_lockAccess) {
            iVIDeviceInfoMutex_.lock();
        } else {
            iVIDeviceInfoMutex_.unlock();
        }
    }
    void lockAudioSourceTypesAttribute(bool _lockAccess) {
        if (_lockAccess) {
            audioSourceTypesMutex_.lock();
        } else {
            audioSourceTypesMutex_.unlock();
        }
    }
    void lockVolumeInfoAttribute(bool _lockAccess) {
        if (_lockAccess) {
            volumeInfoMutex_.lock();
        } else {
            volumeInfoMutex_.unlock();
        }
    }
    void lockKeyValueByteBufferMapAttribute(bool _lockAccess) {
        if (_lockAccess) {
            keyValueByteBufferMapMutex_.lock();
        } else {
            keyValueByteBufferMapMutex_.unlock();
        }
    }
    void lockDeviceStateMapAttribute(bool _lockAccess) {
        if (_lockAccess) {
            deviceStateMapMutex_.lock();
        } else {
            deviceStateMapMutex_.unlock();
        }
    }
    void lockStringToShortMapAttribute(bool _lockAccess) {
        if (_lockAccess) {
            stringToShortMapMutex_.lock();
        } else {
            stringToShortMapMutex_.unlock();
        }
    }

protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
    std::recursive_mutex iVIDeviceInfoMutex_;
    std::recursive_mutex audioSourceTypesMutex_;
    std::recursive_mutex volumeInfoMutex_;
    std::recursive_mutex keyValueByteBufferMapMutex_;
    std::recursive_mutex deviceStateMapMutex_;
    std::recursive_mutex stringToShortMapMutex_;

};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Controller.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ControllerStubRemoteEvent
{
public:
    virtual ~ControllerStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute IVIDeviceInfo
    virtual bool onRemoteSetIVIDeviceInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::Test::Audio::Controller::KeyValueString _value) = 0;
    /// Action callback for remote set requests on the attribute IVIDeviceInfo
    virtual void onRemoteIVIDeviceInfoAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Controller to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ControllerStub
    : public virtual CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>
{
public:
    typedef std::function<void (Controller::FocusControlError _error, Controller::AudioFocusResultType _res)> ObtainFocusReply_t;
    typedef std::function<void (Controller::FocusControlError _error)> ReleaseFocusReply_t;
    typedef std::function<void (Controller::VolumeControlError _error)> SetVolumeReply_t;
    typedef std::function<void (Controller::VolumeControlError _error)> SetSourceVolumeReply_t;
    typedef std::function<void (Controller::ErrorType _error, Controller::AudioSourceStatusInfo _audioSourceStatusInfo)> GetAudioSourceStatusReply_t;

    virtual ~ControllerStub() {}
    void lockInterfaceVersionAttribute(bool _lockAccess) { static_cast<void>(_lockAccess); }
    bool hasElement(const uint32_t _id) const {
        return (_id < 12);
    }
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /*
     * description: 
     * test-purposed attribute which is read-write and map data type
     */
    /// Provides getter access to the attribute IVIDeviceInfo
    virtual const ::v2::Test::Audio::Controller::KeyValueString &getIVIDeviceInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireIVIDeviceInfoAttributeChanged(::v2::Test::Audio::Controller::KeyValueString _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireIVIDeviceInfoAttributeChanged(_value);
    }
    void lockIVIDeviceInfoAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockIVIDeviceInfoAttribute(_lockAccess);
    }
    /*
     * description: 
     * Provides a list of Audio Source Types for ccRC(Rear Seat) System which is provided by the head unit system. 	The list provided to the entire system depending on the resource configuration may be different from the example below.
     * The list has the following format and is a string with upcase letters.
     * -"YOUTUBE_STREAMING"
     * -"TVING_STREAMING"
     * -"WATCHAR_STREAMING"
     */
    /// Provides getter access to the attribute AudioSourceTypes
    virtual const std::vector< std::string > &getAudioSourceTypesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireAudioSourceTypesAttributeChanged(std::vector< std::string > _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireAudioSourceTypesAttributeChanged(_value);
    }
    void lockAudioSourceTypesAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockAudioSourceTypesAttribute(_lockAccess);
    }
    /*
     * description: 
     * Contains the Volume Information include min and max levels.
     * The range of these variables depends on each platform specification.
     * -Volume range is defined by audio specification.
     * -MaxSoftVolume is setted by application which has specific requirements for volume limitation.
     * -LastVolume can be used when ccRC need to store current volume by launching specific functions.
     * -Mute notify the current mute status. (true : Mute / false : Unmute)
     */
    /// Provides getter access to the attribute VolumeInfo
    virtual const ::v2::Test::Audio::Controller::VolumeInfo &getVolumeInfoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireVolumeInfoAttributeChanged(::v2::Test::Audio::Controller::VolumeInfo _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireVolumeInfoAttributeChanged(_value);
    }
    void lockVolumeInfoAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockVolumeInfoAttribute(_lockAccess);
    }
    /// Provides getter access to the attribute KeyValueByteBufferMap
    virtual const ::v2::Test::Audio::Controller::KeyValueByteBuffer &getKeyValueByteBufferMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireKeyValueByteBufferMapAttributeChanged(::v2::Test::Audio::Controller::KeyValueByteBuffer _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireKeyValueByteBufferMapAttributeChanged(_value);
    }
    void lockKeyValueByteBufferMapAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockKeyValueByteBufferMapAttribute(_lockAccess);
    }
    /// Provides getter access to the attribute DeviceStateMap
    virtual const ::v2::Test::Audio::Controller::DeviceStateMap &getDeviceStateMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireDeviceStateMapAttributeChanged(::v2::Test::Audio::Controller::DeviceStateMap _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireDeviceStateMapAttributeChanged(_value);
    }
    void lockDeviceStateMapAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockDeviceStateMapAttribute(_lockAccess);
    }
    /// Provides getter access to the attribute StringToShortMap
    virtual const ::v2::Test::Audio::Controller::StringToShortMap &getStringToShortMapAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// sets attribute with the given value and propagates it to the adapter
    virtual void fireStringToShortMapAttributeChanged(::v2::Test::Audio::Controller::StringToShortMap _value) {
    auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter)
        stubAdapter->fireStringToShortMapAttributeChanged(_value);
    }
    void lockStringToShortMapAttribute(bool _lockAccess) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->lockStringToShortMapAttribute(_lockAccess);
    }
    /*
     * description: 
     * The ccRC system requests to obtain audio focus.
     */
    /// This is the method that will be called on remote calls on the method ObtainFocus.
    virtual void ObtainFocus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, Controller::AudioDeviceType _device, ObtainFocusReply_t _reply) = 0;
    /*
     * description: 
     * The ccRC system requests to release audio focus.  Requests that cannot be released return errors.
     */
    /// This is the method that will be called on remote calls on the method ReleaseFocus.
    virtual void ReleaseFocus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, Controller::AudioDeviceType _device, ReleaseFocusReply_t _reply) = 0;
    /*
     * description: 
     * Set the volume for outside the system.
     */
    /// This is the method that will be called on remote calls on the method SetVolume.
    virtual void SetVolume(const std::shared_ptr<CommonAPI::ClientId> _client, uint8_t _volume, SetVolumeReply_t _reply) = 0;
    /*
     * description: 
     * request to set source volume.
     * There are two member field in the Input parameter.
     * - AudioSourceType: please see "AudioSourceTypes []" for finding detail description
     * - volume : it holds volume level and its level is depending on platform's audio  spec. (varies based on platform, model, misc.)
     * : when this method is invoked, audio manager need to update VolumeInfo.LastVolume
     * 
     * - maxVolume : it defines volume limitation which is described from the requirement
     * - VolumeControlError : please see "setVolume" for more detail explanation
     */
    /// This is the method that will be called on remote calls on the method SetSourceVolume.
    virtual void SetSourceVolume(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, uint16_t _volume, uint32_t _maxVolume, SetSourceVolumeReply_t _reply) = 0;
    /*
     * description: 
     * Get FocusStatus and VolumeInfo for audio source type
     */
    /// This is the method that will be called on remote calls on the method GetAudioSourceStatus.
    virtual void GetAudioSourceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _audioSourceType, GetAudioSourceStatusReply_t _reply) = 0;
    /*
     * description: 
     * broadcast when audio source type changed
     */
    /// Sends a broadcast event for FocusStatusChanged.
    virtual void fireFocusStatusChangedEvent(const std::vector< ::v2::Test::Audio::Controller::FocusStatus > &_focusStatus) {
        auto stubAdapter = CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireFocusStatusChangedEvent(_focusStatus);
    }


    using CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<ControllerStubAdapter, ControllerStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef ControllerStubRemoteEvent RemoteEventType;
    typedef Controller StubInterface;
};

} // namespace Audio
} // namespace Test
} // namespace v2


// Compatibility
namespace v2_0 = v2;

#endif // V2_TEST_AUDIO_Controller_STUB_HPP_
